# 1 "/home/arthus/build/PsNee/PsNee.ino"
// PsNee / psxdev.net version
// For Arduino and ATtiny
//
// Quick start: Select your hardware via the #defines, compile + upload the code, install in PSX.
// There are some pictures in the development thread ( http://www.psxdev.net/forum/viewtopic.php?f=47&t=1262&start=120 )
// Beware to use the PSX 3.5V / 3.3V power, *NOT* 5V! The installation pictures include an example.
//
// Arduinos:
//  - Arduino Pro Mini @8Mhz and @16Mhz (supported, tested)
//  - Arduino Uno @8Mhz and @16Mhz (supported, tested)
//  - Arduino Pro Micro has a different pin assignment and needs some easy porting. (ToDo)
//  - Use #define ARDUINO_BOARD
// ATtiny:
//  - ATtiny85: Should work the same as ATtiny45 (supported, untested)
//  - ATtiny45: LFUSE 0xE2  HFUSE 0xDF > internal oscillator, full 8Mhz speed (supported, tested)
//  - ATtiny25: Should work the same as ATtiny45 but doesn't have enough Flash nor RAM for PSNEEDEBUG (supported, untested)
//  - Use #define ATTINY_X5
//
// To use ATtiny with the Arduino environment, an ATtiny core has to be installed.
//
// PAL PM-41 consoles are supported with #define APPLY_PSONE_PAL_BIOS_PATCH,
// but only on boards with ATmega chips (Arduinos).
// Also, the Arduino must be flashed using SPI (deleting the bootloader), since I expect a signal ~1 second after power on.
//
// This code defaults to multi-region, meaning it will unlock PAL, NTSC-U and NTSC-J machines.
// You can optimize boot times for your console further. See "// inject symbols now" in the main loop.

//+-------------------------------------------------------------------------------------------+
//|                                  Choose your hardware!                                    |
//+-------------------------------------------------------------------------------------------+
// 2 main branches available:
//  - ATmega based > easy to use, fast and nice features for development, recommended
//  - ATtiny based > for minimal installs

//#define ARDUINO_BOARD


//#define APPLY_PSONE_PAL_BIOS_PATCH

//#define PSNEEDEBUG

# 43 "/home/arthus/build/PsNee/PsNee.ino" 2
# 70 "/home/arthus/build/PsNee/PsNee.ino"

# 70 "/home/arthus/build/PsNee/PsNee.ino"
// extras

// board pins (Do not change. Changing pins requires adjustments to MCU I/O definitions)





// MCU I/O definitions
# 114 "/home/arthus/build/PsNee/PsNee.ino"
// Setup() detects which (of 2) injection methods this PSX board requires, then stores it in pu22mode.
boolean pu22mode;

//Timing
const int delay_between_bits = 4000; // 250 bits/s (microseconds) (ATtiny 8Mhz works from 3950 to 4100)
const int delay_between_injections = 90; // 72 in oldcrow. PU-22+ work best with 80 to 100 (milliseconds)

// borrowed from AttyNee. Bitmagic to get to the SCEX strings stored in flash (because Harvard architecture)
bool readBit(int index, const unsigned char *ByteSet)
{
  int byte_index = index >> 3;
  byte bits = 
# 125 "/home/arthus/build/PsNee/PsNee.ino" 3
             (__extension__({ uint16_t __addr16 = (uint16_t)((uint16_t)(
# 125 "/home/arthus/build/PsNee/PsNee.ino"
             &(ByteSet[byte_index])
# 125 "/home/arthus/build/PsNee/PsNee.ino" 3
             )); uint8_t __result; __asm__ __volatile__ ( "lpm %0, Z" "\n\t" : "=r" (__result) : "z" (__addr16) ); __result; }))
# 125 "/home/arthus/build/PsNee/PsNee.ino"
                                                  ;
  int bit_index = index & 0x7; // same as (index - byte_index<<3) or (index%8)
  byte mask = 1 << bit_index;
  return (0 != (bits & mask));
}

void inject_SCEX(char region)
{
  //SCEE: 1 00110101 00, 1 00111101 00, 1 01011101 00, 1 01011101 00
  //SCEA: 1 00110101 00, 1 00111101 00, 1 01011101 00, 1 01111101 00
  //SCEI: 1 00110101 00, 1 00111101 00, 1 01011101 00, 1 01101101 00
  //const boolean SCEEData[44] = {1,0,0,1,1,0,1,0,1,0,0,1,0,0,1,1,1,1,0,1,0,0,1,0,1,0,1,1,1,0,1,0,0,1,0,1,0,1,1,1,0,1,0,0};
  //const boolean SCEAData[44] = {1,0,0,1,1,0,1,0,1,0,0,1,0,0,1,1,1,1,0,1,0,0,1,0,1,0,1,1,1,0,1,0,0,1,0,1,0,1,1,1,0,1,0,0};
  //const boolean SCEIData[44] = {1,0,0,1,1,0,1,0,1,0,0,1,0,0,1,1,1,1,0,1,0,0,1,0,1,0,1,1,1,0,1,0,0,1,0,1,0,1,1,1,0,1,0,0};
  static const 
# 139 "/home/arthus/build/PsNee/PsNee.ino" 3
              __attribute__((__progmem__)) 
# 139 "/home/arthus/build/PsNee/PsNee.ino"
                      unsigned char SCEEData[] = {0b01011001, 0b11001001, 0b01001011, 0b01011101, 0b11101010, 0b00000010};
  static const 
# 140 "/home/arthus/build/PsNee/PsNee.ino" 3
              __attribute__((__progmem__)) 
# 140 "/home/arthus/build/PsNee/PsNee.ino"
                      unsigned char SCEAData[] = {0b01011001, 0b11001001, 0b01001011, 0b01011101, 0b11111010, 0b00000010};
  static const 
# 141 "/home/arthus/build/PsNee/PsNee.ino" 3
              __attribute__((__progmem__)) 
# 141 "/home/arthus/build/PsNee/PsNee.ino"
                      unsigned char SCEIData[] = {0b01011001, 0b11001001, 0b01001011, 0b01011101, 0b11011010, 0b00000010};

  // pinMode(data, OUTPUT) is used more than it has to be but that's fine.
  for (byte bit_counter = 0; bit_counter < 44; bit_counter++)
  {
    if (readBit(bit_counter, region == 'e' ? SCEEData : region == 'a' ? SCEAData : SCEIData) == 0)
    {
      pinMode(2, 0x1);
      ((
# 149 "/home/arthus/build/PsNee/PsNee.ino" 3
     (*(volatile uint8_t *)((0x16) + 0x20))
# 149 "/home/arthus/build/PsNee/PsNee.ino"
     ) &= ~(1UL << (2))); // data low
      delayMicroseconds(delay_between_bits);
    }
    else
    {
      if (pu22mode) {
        pinMode(2, 0x1);
        unsigned long now = micros();
        do {
          bool wfck_sample = (((
# 158 "/home/arthus/build/PsNee/PsNee.ino" 3
                            (*(volatile uint8_t *)((0x16) + 0x20))
# 158 "/home/arthus/build/PsNee/PsNee.ino"
                            ) >> (4)) & 0x01);
          ((wfck_sample) ? ((
# 159 "/home/arthus/build/PsNee/PsNee.ino" 3
         (*(volatile uint8_t *)((0x18) + 0x20))
# 159 "/home/arthus/build/PsNee/PsNee.ino"
         ) |= (1UL << (2))) : ((
# 159 "/home/arthus/build/PsNee/PsNee.ino" 3
         (*(volatile uint8_t *)((0x18) + 0x20))
# 159 "/home/arthus/build/PsNee/PsNee.ino"
         ) &= ~(1UL << (2)))); // output wfck signal on data pin
        }
        while ((micros() - now) < delay_between_bits);
      }
      else { // PU-18 or lower mode
        pinMode(2, 0x0);
        delayMicroseconds(delay_between_bits);
      }
    }
  }

  pinMode(2, 0x1);
  ((
# 171 "/home/arthus/build/PsNee/PsNee.ino" 3
 (*(volatile uint8_t *)((0x16) + 0x20))
# 171 "/home/arthus/build/PsNee/PsNee.ino"
 ) &= ~(1UL << (2))); // pull data low
  delay(delay_between_injections);
}

void NTSC_fix() {
# 203 "/home/arthus/build/PsNee/PsNee.ino"
}

//--------------------------------------------------
//     Setup
//--------------------------------------------------

void setup()
{
  pinMode(2, 0x0);
  pinMode(4, 0x0);
  pinMode(1, 0x0); // PSX subchannel bits
  pinMode(0, 0x0); // PSX subchannel clock
# 230 "/home/arthus/build/PsNee/PsNee.ino"
  // wait for console power on and stable signals
  while (!digitalRead(0));
  while (!digitalRead(4));

  // if enabled: patches PAL PSOne consoles so they start all region games
  NTSC_fix();

  // Board detection
  //
  // GATE: __-----------------------  // this is a PU-7 .. PU-20 board!
  //
  // WFCK: __-_-_-_-_-_-_-_-_-_-_-_-  // this is a PU-22 or newer board!

  unsigned int highs = 0, lows = 0;
  unsigned long now = millis();
  do {
    if (digitalRead(4) == 1) highs++;
    if (digitalRead(4) == 0) lows++;
    delayMicroseconds(200); // good for ~5000 reads in 1s
  }
  while ((millis() - now) < 1000); // sample 1s

  // typical readouts
  // PU-22: highs: 2449 lows: 2377
  if (lows > 100) {
    pu22mode = 1;
  }
  else {
    pu22mode = 0;
  }


  ; ;
# 279 "/home/arthus/build/PsNee/PsNee.ino"
  ; // empty serial transmit buffer
}

void loop()
{
  static byte scbuf [12] = { 0 }; // We will be capturing PSX "SUBQ" packets, there are 12 bytes per valid read.
  static unsigned int timeout_clock_counter = 0;
  static byte bitbuf = 0; // SUBQ bit storage
  static bool sample = 0;
  static byte bitpos = 0;
  byte scpos = 0; // scbuf position

  // start with a small delay, which can be necessary in cases where the MCU loops too quickly
  // and picks up the laster SUBQ trailing end
  delay(1);

  
# 295 "/home/arthus/build/PsNee/PsNee.ino" 3
 __asm__ __volatile__ ("cli" ::: "memory")
# 295 "/home/arthus/build/PsNee/PsNee.ino"
               ; // start critical section
start:
  // Capture 8 bits for 12 runs > complete SUBQ transmission
  bitpos = 0;
  for (; bitpos < 8; bitpos++) {
    while ((((
# 300 "/home/arthus/build/PsNee/PsNee.ino" 3
          (*(volatile uint8_t *)((0x16) + 0x20))
# 300 "/home/arthus/build/PsNee/PsNee.ino"
          ) >> (0)) & 0x01) == 1) {
      // wait for clock to go low..
      // a timeout resets the 12 byte stream in case the PSX sends malformatted clock pulses, as happens on bootup
      timeout_clock_counter++;
      if (timeout_clock_counter > 1000) {
        scpos = 0; // reset SUBQ packet stream
        timeout_clock_counter = 0;
        bitbuf = 0;
        goto start;
      }
    }

    // wait for clock to go high..
    while (((((
# 313 "/home/arthus/build/PsNee/PsNee.ino" 3
           (*(volatile uint8_t *)((0x16) + 0x20))
# 313 "/home/arthus/build/PsNee/PsNee.ino"
           ) >> (0)) & 0x01)) == 0);

    sample = (((
# 315 "/home/arthus/build/PsNee/PsNee.ino" 3
            (*(volatile uint8_t *)((0x16) + 0x20))
# 315 "/home/arthus/build/PsNee/PsNee.ino"
            ) >> (1)) & 0x01);
    bitbuf |= sample << bitpos;

    timeout_clock_counter = 0; // no problem with this bit
  }

  // one byte done
  scbuf[scpos] = bitbuf;
  scpos++;
  bitbuf = 0;

  // repeat for all 12 bytes
  if (scpos < 12) {
    goto start;
  }
  
# 330 "/home/arthus/build/PsNee/PsNee.ino" 3
 __asm__ __volatile__ ("sei" ::: "memory")
# 330 "/home/arthus/build/PsNee/PsNee.ino"
             ; // end critical section

  // log SUBQ packets. We only have 12ms to get the logs written out. Slower MCUs get less formatting.

  if (!(scbuf[0] == 0 && scbuf[1] == 0 && scbuf[2] == 0 && scbuf[3] == 0)) { // a bad sector read is all 0 except for the CRC fields. Don't log it.
    for (int i = 0; i < 12; i++) {
      if (scbuf[i] < 0x10) {
        ; // padding
      }
      ;
    }
    ;
  }
# 356 "/home/arthus/build/PsNee/PsNee.ino"
  // check if read head is in wobble area
  // We only want to unlock game discs (0x41) and only if the read head is in the outer TOC area.
  // We want to see a TOC sector repeatedly before injecting (helps with timing and marginal lasers).
  // All this logic is because we don't know if the HC-05 is actually processing a getSCEX() command.
  // Hysteresis is used because older drives exhibit more variation in read head positioning.
  // While the laser lens moves to correct for the error, they can pick up a few TOC sectors.
  static byte hysteresis = 0;
  boolean isDataSector = (((scbuf[0] & 0x40) == 0x40) && (((scbuf[0] & 0x10) == 0) && ((scbuf[0] & 0x80) == 0)));

  if (
    (isDataSector && scbuf[1] == 0x00 && scbuf[6] == 0x00) && // [0] = 41 means psx game disk. the other 2 checks are garbage protection
    (scbuf[2] == 0xA0 || scbuf[2] == 0xA1 || scbuf[2] == 0xA2 || // if [2] = A0, A1, A2 ..
     (scbuf[2] == 0x01 && (scbuf[3] >= 0x98 || scbuf[3] <= 0x02) ) ) // .. or = 01 but then [3] is either > 98 or < 02
  ) {
    hysteresis++;
  }
  else if ( hysteresis > 0 &&
            ((scbuf[0] == 0x01 || isDataSector) && (scbuf[1] == 0x00 /*|| scbuf[1] == 0x01*/) && scbuf[6] == 0x00)
          ) { // This CD has the wobble into CD-DA space. (started at 0x41, then went into 0x01)
    hysteresis++;
  }
  else if (hysteresis > 0) {
    hysteresis--; // None of the above. Initial detection was noise. Decrease the counter.
  }

  // hysteresis value "optimized" using very worn but working drive on ATmega328 @ 16Mhz
  // should be fine on other MCUs and speeds, as the PSX dictates SUBQ rate
  if (hysteresis >= 14) {
    // If the read head is still here after injection, resending should be quick.
    // Hysteresis naturally goes to 0 otherwise (the read head moved).
    hysteresis = 11;


    ;







    pinMode(2, 0x1);
    digitalWrite(2, 0); // pull data low
    if (!pu22mode) {
      pinMode(4, 0x1);
      digitalWrite(4, 0);
    }

    // HC-05 waits for a bit of silence (pin low) before it begins decoding.
    delay(delay_between_injections);
    // inject symbols now. 2 x 3 runs seems optimal to cover all boards
    for (byte loop_counter = 0; loop_counter < 2; loop_counter++)
    {
      inject_SCEX('e'); // e = SCEE, a = SCEA, i = SCEI
      //inject_SCEX('a'); // injects all 3 regions by default
      //inject_SCEX('i'); // optimize boot time by sending only your console region letter (all 3 times per loop)
    }

    if (!pu22mode) {
      pinMode(4, 0x0); // high-z the line, we're done
    }
    pinMode(2, 0x0); // high-z the line, we're done



  }
  // keep catching SUBQ packets forever
}
